/* rexx                                                              */

/* Converting WinWord 6.0 Document file for import to StarWriter 3.1 */
/*          ATTENTION!!! File will be overwritting                   */
/*                                                                   */
/*       The script do not convert russian '', sorry                */

/* Author: Paul Schedrin, Krasnodar                                  */
/* FIDO:   2:5063/8.5                                                */
/* iNet:   paul@ist.kuban.ru                                         */
/* SPRINT: CERTABANK/SKAT                                            */

Say "                                       "
Say " run: make3.cmd wordfile.doc           "
Say "                                       "
parse arg wordfile
alt  = ""
win  = "''c.-|$""""׃Ѧݯ"
marker = x2c('dca5 6500')
fsize = chars(wordfile)
if fsize < x2d(b80)
  then do
    say 'File 'wordfile' is not WinWord Document'
    exit
  end
say 'File' wordfile fsize 'bytes is' stream(wordfile, 'c', 'open')
wholebuff = charin(wordfile,1,fsize)
foffset = pos(marker,wholebuff) + x2d(300)
period = 1
Do While period > 0
  textbody = substr(wholebuff,foffset)
  textlast = pos(x2c('0000'),textbody)
  checkend = pos(x2c('00'),textbody)
  if textlast = checkend then endblock = trunc(checkend/16)*16
     else endblock = checkend
  say 'Converting block' period 'size' endblock 'from' d2x(foffset)
  newbody = substr(textbody,1,endblock)
  textbody = translate(newbody,win,alt)
  if charout(wordfile,textbody,foffset) \= 0
    then do
      say 'Operation NOT successful'
    end
  if textlast = checkend
     then do
       foffset = foffset + endblock + 512
       period = period + 1
     end
  else period = 0
end
say 'File' wordfile 'is' stream(wordfile, 'c', 'close') 'to close'
exit